#include "sim_ext.h"

char *GetHeader()
{
char *user;
char *name;
char *directory;
char hostname[100];
static char line[1000];
char *getenv();

    if((user=getenv("USER")) == NULL){
	    user = "???";
    }
    if((name=getenv("NAME")) == NULL){
	    name = "???";
    }
    if((directory=getenv("PWD")) == NULL){
	    directory = "???";
    }
    gethostname(hostname,100);
    sprintf(line,"%s : %s@%s : %s\n%s",
    name,
    user,
    hostname,
    directory,
    date()
    );
    return(line);
}

Notes(fp)
FILE *fp;
{
char line[1000];
char *ptr;

    if(fp == NULL) return;
    printf("End with '.' alone on the last line\n");
    AlternatePrompt("->");
    EnableHistory(0);
    fprintf(fp,
"+--------------------------------------------------------------------------+\n"
    );
    strcpy(line,date());
    do{
	fprintf(fp,"%s\n",line);
	fflush(stdout);
	GetLineFp(line,stdin,1000);
	/*
	** zap the CR
	*/
	if(ptr = strchr(line,'\n'))
	    *ptr = '\0';
    } while(!((line[0] == '.') && (line[1] == '\0')));
    fclose(fp);
    AlternatePrompt(NULL);
    EnableHistory(1);
}

do_notes(argc,argv)
int argc;
char **argv;
{
FILE *fp;
static char current_file[100] = {""};

    if(argc > 1){
	strcpy(current_file,argv[1]);
    }
    /*
    ** if the current note file has not been specified then
    ** try the SIMNOTES env variable
    */
    if(strlen(current_file) == 0){
	if(getenv("SIMNOTES")){
	    strcpy(current_file,getenv("SIMNOTES"));
	} else {
	    /*
	    ** use the default
	    */
	    strcpy(current_file,"notes");
	}
    }
    /*
    ** open the default note file
    */
    fp = fopen(current_file,"a");
    if(fp == NULL){
	printf("unable to open file %s\n");
	return;
    }
    printf("using notes file '%s'\n",current_file);
    Notes(fp);
}

