//genesis
/*******************************************************************
**                                                                **
**                                                                **
**      Genlib.g  : genesis-xodus linkup library script calls.    **
**                                                                **
**                                                                **
*******************************************************************/

newclass	widget		
newclass	form	
addaction DELETE 9

object	xform	xform_type	xform_func	form \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author	"J. D. Uhley 1989" \
	-description "Contains other widgets, oversees their positioning," \
		"interacts with the window manager."

object	xlabel	xlabel_type	xlabel_func	widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author	"U.S. Bhalla 1988" \
	-description "Just a boring label - no operations."

object	xbutton	xbutton_type	xbutton_func	widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author	"X toolkit command widget, modified by U.S. Bhalla 1988" \
	-description "Executes script commands when mouse is clicked."

object	xdialog	xdialog_type	xdialog_func	widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S. Bhalla 1988" \
	-description "Widget for text entry and display. Executes script " \
	"commands when button clicked or return pressed in text area."

object	xtoggle	xtoggle_type	xtoggle_func	widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author	"U.S. Bhalla 1989" \
	-description "Button that toggles between state 1 and 0, with" \
	"appropriate changes to appearance and (optionally) label"

object	xgraph	xaxisgraph_type	xaxisgraph_func	widget output \
	-messages	PLOT 0 		3 data name color \
			PLOTSCALE 1	5 data name color scale yoffset \
	-actions	SET CREATE DELETE  PROCESS RESET \
	-environment	SPECIAL_SET 1 \
	-author "J. D. Uhley, U. S. Bhalla., 1988" \
	-description "Plots graphs. Options allow multiple graphs, data from" \
	"files or via message passing, phase plots, etc. Widget uses" \
	"additional memory depending on number of points, beware!" \
	"Has a bug  which leads to incorrect plot size when first displayed," \
	"but the right size appears as soon as it is rescaled."

object	xdraw	xdraw_type	xdraw_func		widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "Displays objects in 3-d space. Permits various" \
	"transformations from space onto the screen, including orthographic," \
	"orthogonal and perspective. Size, location, and orientation of" \
	"image may be specified. All objects displayed in this are called" \
	"'pixes'. Hilighting and selection by mouse clicks are supported." 

object	xview	xview_type	xview_func		widget output \
	-actions	PROCESS SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "This is a pix which must be displayed in a draw widget" \
	"It displays the 3-d positions of elements and uses color and/or" \
	"size coding to indicate the value of fields of those elements." \
	"Clicks return the path of the element that was clicked on."


object	xconn	xconn_type	xconn_func		widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "This is a pix which must be displayed in a draw widget" \
	"It displays the connectivity between planes of cells. Options permit" \
	"anterograde/retrograde labelling of connected cells."

object	xelmtree	xelmtree_type	xelmtree_func		widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "This is a pix which must be displayed in a draw widget" \
	"It requires that the draw widget have cx = cy = 500, and" \
	"wx=wy=1000. It displays the tree hierarchy of the simulation." \
	"Clicks return the path of the element that was clicked on"

object	xcell	xcell_type	xcell_func		widget output \
	-actions	PROCESS SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "This is a pix which must be displayed in a draw widget" \
	"It displays a neuron in 3-d. The geometry is based on the coordinates" \
	"of the compartments. Both color and size coding may be used to indicate" \
	"values of fields in the compartments. The special 'calc_dia' option" \
	"permits one to estimate the diameter of the compartment from electrical" \
	"properties for display purposes." \
	"Clicks return the path of the element that was clicked on."

object	xshape	xshape_type	xshape_func		widget \
	-actions	SET CREATE DELETE COPY  \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "This is a pix which must be displayed in a draw widget" \
	"It displays shapes specified by coordinates, drawmodes and text" \
	"fields. The 'value' field is returned when it is clicked"

object	xfileview	xfileview_type	xfileview_func		widget \
	-actions	SET CREATE DELETE   \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1989" \
	-description "This is a pix which must be displayed in a draw widget" \
	"It is very similar to the view widget except that it gets its data" \
	"from files. It permits one to display the history of a simulation."


object	ximage		ximage_type	ximage_func		widget \
	-actions	SET CREATE DELETE \
	-environment	SPECIAL_SET 1 \
	-author "U.S.Bhalla 1990" \
	-description "Displays any image" \
	"It uses the X11 'image' facility to draw bitmap and pixmap images." \
	"At present the images must be loaded in from a file in gif format."

object  xtext   xtext_type  xtext_func  widget \
	-actions    SET CREATE DELETE   \
	-environment    SPECIAL_SET 1 \
	-author "J.D. Uhley 1990" \
	-description "Just a boring asciitext ."

